unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Grids, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    DrawGrid1: TDrawGrid;
    procedure DrawGrid1DrawCell(Sender: TObject; aCol, aRow: integer;
      aRect: TRect; aState: TGridDrawState);
    procedure DrawGrid1Selection(Sender: TObject; aCol, aRow: integer);
    procedure FormCreate(Sender: TObject);
  private
    Feld: array of array of record
      Schiff: boolean;
      geklickt: boolean;
    end;

  public

  end;

var
  Form1: TForm1;

const
  max: TPoint = (x: 10; y: 10);

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.DrawGrid1DrawCell(Sender: TObject; aCol, aRow: integer;
  aRect: TRect; aState: TGridDrawState);
begin

  if (aCol > 0) and (aRow > 0) then begin
    with DrawGrid1 do begin
      if Feld[aCol - 1, aRow - 1].geklickt then begin
        Canvas.Brush.Color := clRed;
        Canvas.FillRect(aRect);
      end else begin
        if Feld[aCol - 1, aRow - 1].Schiff then begin
          Canvas.Brush.Color := clMaroon;
          Canvas.FillRect(aRect);
        end else begin
          Canvas.Brush.Color := clWhite;
          Canvas.FillRect(aRect);
        end;
      end;
    end;
  end;

  if (aCol = 0) and (aRow > 0) then begin
    DrawGrid1.Canvas.TextOut(aRect.Left, aRect.Top, IntToStr(aRow));
  end;
  if (aCol > 0) and (aRow = 0) then begin
    DrawGrid1.Canvas.TextOut(aRect.Left, aRect.Top, char(aCol + 64));
  end;
end;

procedure TForm1.DrawGrid1Selection(Sender: TObject; aCol, aRow: integer);
begin
  if (aCol > 0) and (aRow > 0) then begin
    Feld[aCol - 1][aRow - 1].geklickt := True;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: integer;
begin
  SetLength(Feld, max.x, max.y);
  for i := 3 to 6 do begin
    Feld[i, 3].Schiff := True;
  end;
  with DrawGrid1 do begin
    ScrollBars := ssNone;
    Left := 0;
    Top := 0;
    ColCount := max.x + 1;
    RowCount := max.y + 1;
    DefaultColWidth := 32;
    DefaultRowHeight := 32;
    Width := DefaultColWidth * ColCount + 2;
    Height := DefaultRowHeight * RowCount + 2;
  end;
end;

end.
